
int   gridLength = 100;
boolean drawCones = true;
boolean drawLabels = true;

//vals fpr labels
float lab_angle = HALF_PI/4;
int lab_thick = 20;
int lab_len = 100;
int lab_offs = 1;
float ObjsScale = 0.02;

void drawGrid(){
  //x
  stroke(XCol);
  line(-gridLength, 0, 0, gridLength, 0, 0);
  //y
  stroke(YCol);
  line(0, -gridLength, 0, 0, gridLength, 0);
  
  //z
  stroke(ZCol);
  line(0, 0, -gridLength, 0, 0, gridLength);
  
  if (drawCones){
  //draw x cone at end of line
    pushMatrix();
    noStroke();
    fill(XCol);
    translate(gridLength,0,0);          //move to end of line
    rotateZ(HALF_PI);                      //and rotate around Z axis
    scale(ObjsScale);
    drawCylinder(0,50,50,200);
    popMatrix();
    
    //draw y cone at end of line
    pushMatrix();
    noStroke();
    fill(YCol);
    translate(0,gridLength,0);          //move to end of line
    rotateX(PI);
    scale(ObjsScale);
    drawCylinder(0,50,50,200);
    popMatrix();

    pushMatrix();
    noStroke();
    fill(ZCol);
    translate(0,0,gridLength);          //move to end of line
    rotateX(-HALF_PI);
    scale(ObjsScale);
    drawCylinder(0,50,50,200);
    popMatrix();
  
  }
  
  if (drawLabels){
    noStroke();
    //X
    pushMatrix();
    translate(gridLength+lab_offs,0,0);          //move to end of line
    scale(ObjsScale);
    fill(XCol);
    drawXLabel();
    popMatrix();
    //Y
    pushMatrix();
    translate(0,gridLength+lab_offs,0);          //move to end of line
    scale(ObjsScale);
    rotateX(PI);
    fill(YCol);
    drawYLabel();
    popMatrix();
    //Z
    pushMatrix();
    translate(0,0,gridLength+lab_offs);          //move to end of line
    scale(ObjsScale);
    rotateY(HALF_PI);
    fill(ZCol);
    drawZLabel();
    popMatrix();
    
  }
  
 
}

void drawCylinder(float topRadius, float bottomRadius, float tall, int sides) {
  float angle = 0;
  float angleIncrement = TWO_PI / sides;
  beginShape(QUAD_STRIP);
  for (int i = 0; i < sides + 1; ++i) {
    vertex(topRadius*cos(angle), 0, topRadius*sin(angle));
    vertex(bottomRadius*cos(angle), tall, bottomRadius*sin(angle));
    angle += angleIncrement;
  }
  endShape();
  
  // If it is not a cone, draw the circular top cap
  if (topRadius != 0) {
    angle = 0;
    beginShape(TRIANGLE_FAN);
    
    // Center point
    vertex(0, 0, 0);
    for (int i = 0; i < sides + 1; i++) {
      vertex(topRadius * cos(angle), 0, topRadius * sin(angle));
      angle += angleIncrement;
    }
    endShape();
  }

  // If it is not a cone, draw the circular bottom cap
  if (bottomRadius != 0) {
    angle = 0;
    beginShape(TRIANGLE_FAN);

    // Center point
    vertex(0, tall, 0);
    for (int i = 0; i < sides + 1; i++) {
      vertex(bottomRadius * cos(angle), tall, bottomRadius * sin(angle));
      angle += angleIncrement;
    }
    endShape();
  }
}

void drawXLabel(){
  
 //left leaning box
 pushMatrix();
 rotateZ(-lab_angle);
 box(lab_thick,lab_len,lab_thick);
 popMatrix();
 
  //right leaning box
 pushMatrix();
 rotateZ(lab_angle);
 box(lab_thick,lab_len,lab_thick);
 popMatrix();
}

void drawYLabel(){
 //left leaning box
 pushMatrix();
 rotateZ(-lab_angle);
 translate(-lab_len/20,-lab_len/4,0);
 box(lab_thick,lab_len/2,lab_thick);
 popMatrix();
 
 
  //right leaning box
 pushMatrix();
 rotateZ(lab_angle);
 box(lab_thick,lab_len,lab_thick);
 popMatrix();
 
}

void drawZLabel(){
   //right leaning box
 pushMatrix();
 rotateZ(lab_angle);
 box(lab_thick,lab_len,lab_thick);
 popMatrix();

 //upper bar
 pushMatrix();
 translate(0,-lab_len/2,0);
 box(lab_len/1.8,lab_thick,lab_thick);
 popMatrix();
 
 //lower bar
 pushMatrix();
 translate(0,lab_len/2,0);
 box(lab_len/1.8,lab_thick,lab_thick);
 popMatrix();

}
