
int   lineSensScale = 100;
float lineScale = ((float)gridLength/dataPoints);

//rotate the line graphs around, values are in radians
float rotXLine = 0;
float rotYLine = 0;
float rotZLine = 0;
//shift the lines, a value of 0 eq. starting at (0,0,0)
float shiftXLine = 0;
float shiftYLine = 0;
float shiftZLine = 0;

void drawLineGraph(){

  int x;
  float xx;
  float[] v;

  for (int i = 0; i < dataPoints; i++){
      
      //float xv = (Histo[ (Idx+i)%dataPoints ][0] * lineSensScale);
      //running Index into vals, which is decrementing
      x = (Idx-i)%dataPoints;
      if (x<0) x = dataPoints+x;
      //get [3] vals using index x
      v = Histo[x];
      //and scale xx, the point to drawn on the line
      xx = i*lineScale;

      //start with xHisto[Idx} at 0,0
      //draw x
      //angle = 0: draw into y of screen coords which is up-down
      pushMatrix();
      translate(0, shiftXLine, 0);
      rotateX(rotXLine);
      stroke(XCol);
      line(0 , xx, 0, v[0]*lineSensScale, xx, 0);
      popMatrix();
      
      //draw y, y of sensor is line through screen towards you
      //keep in mind that screen's and sensor's y&z axis are switched
      //angle=0: draw into x of screen, which is left-right
      pushMatrix();
      translate(shiftYLine, 0, 0);
      rotateX(rotYLine);
      stroke(ZCol);
      line(xx, 0, 0, xx, 0, v[1]*lineSensScale);
      popMatrix();

      //draw z, z of sensor is vertical to earth's surface
      //draw into z of screen which is line "into" screen
      pushMatrix();
      translate(0, 0, shiftZLine);
      rotateX(rotZLine);
      stroke(YCol);
      line(0, 0, xx, 0, v[2]*lineSensScale, xx);
      popMatrix();
      
  }  
}
